% messing with mushroom,  again 4/10/06

% make complete list of levels of mushroom: 30 mins on oliver for 3<k<300

dk = 0.1;
opts.Mo = 500;
opts.v = 0;

bil = '-l hamush:1:1 ';
sys = [bil '-s fb:3:0:1.5 -u -4 3'];
[ks, prop, err, bdry] = gen_levels(3, 10, dk, dk, sys, opts);

sys = [bil '-s fb:1.5:0:1.5 -u -4 3'];
[ks_t, prop_t, err_t, bdry_t] = gen_levels(10, 30, dk, dk, sys, opts);  
[ks, err, bdry] = merge_levels(ks, ks_t, err, err_t, bdry, bdry_t);

sys = [bil '-s fb:1:0:1.5 -u -4 3'];
[ks_t, prop_t, err_t, bdry_t] = gen_levels(30, 100, dk, dk, sys, opts);  
[ks, err, bdry] = merge_levels(ks, ks_t, err, err_t, bdry, bdry_t);

sys = [bil '-s fb:1:0:1.5 -u -4 3'];
[ks_t, prop_t, err_t, bdry_t] = gen_levels(100, 200, dk, dk, sys, opts);  
[ks, err, bdry] = merge_levels(ks, ks_t, err, err_t, bdry, bdry_t);
% took 480 minutes on 1 cpu of whisky


ne = numel(ks);
%save mu0-200.mat ne ks err bdry prop opts sys

% remove duplicates: find them first ----was 4 of them!... run with nei=1,2
norms = sqrt(dot(bdry.ngr,bdry.ngr,2)); nei = 2; % how far to look neighbors
diago = sum(bdry.ngr(1:end-nei,:).*bdry.ngr(1+nei:end,:), 2);
coso = diago ./ (norms(1:end-nei).*norms(1+nei:end));    % norm to get cos angs
j_dups = find(abs(coso)>0.99);                 % adjust cutoff dep on acc
ind = ones(1,ne); ind(j_dups) = 0;
j_keep = find(ind); ne = numel(j_keep);
ks = ks(j_keep); bdry.ngr = bdry.ngr(j_keep,:); bdry.per = bdry.per(j_keep,:);
err.ten = err.ten(j_keep);err.nrm = err.nrm(j_keep);err.kos = err.kos(j_keep);
% -----------------------------------------------------------------
%save mu0-100_clean.mat ne ks err bdry prop opts sys
%save mu0-200_clean.mat ne ks err bdry prop opts sys k_weyl diagQ Es Mo
%save mu0-300_clean.mat ne ks err bdry prop opts sys Es Mo
% --------
load mu0-100_clean

figure; semilogy(ks, err.ten);
figure; axes('position', [.1 .1 .8 .4]);
k_weyl = weyl(0, ks, prop.perim, prop.area);
print -deps2 mu0-100weyl.eps
% levels are being found (duplicates)
Mo = opts.Mo;
Es = ks.^2;  

% demo that errors are purely scaling-cubic related
figure; semilogy(abs(ks-err.kos), err.ten, '+');

% compute Q
[Q] = triple(bdry.ngr, ones([1 Mo]), bdry.rn, bdry.dx, ne);
save Q.mu.mat Q ne
figure; imagesc(abs(Q)); colormap gray; colorbar;

% compute Q for a `foot-sensing' func, 1 in foot bdry part....
foot = zeros(size(bdry.rn));
foot(1:floor(1.5/bdry.dx)) = 1;   %figure;plot([foot; bdry.rn]'); % check
[Q] = triple(bdry.ngr, ones([1 Mo]), foot, bdry.dx, ne);
%save Q.mu.mat Q ne
figure; imagesc(-abs(Q)); colormap gray; colorbar; title('foot Q');

% diag Q only...
diagQ = triple(bdry.ngr, ones([1 Mo]), foot, bdry.dx, ne, 1);
figure; plot(ks, diagQ./ks.^2, '.'); xlabel('k_j');
ylabel('diag foot Q / k_j^2');
save foot_diag0-100 ks diagQ Mo Es ne

% band prof
[mean_m, counts, bin_ctrs] = band_prof(ks, Q.^2, 0.05, 20);
figure; plot(bin_ctrs, mean_m); title('band prof: foot'); xlabel('dk');

% plot subset of bdry funcs as img... output at high res
Mo = numel(bdry.rn);
%js = 1:ne; %js = 1:100;
% select using in-foot criterion for ergodic:
js = find(diagQ./Es>1e-3 & (1:ne)'>100);      % ergodic
%js = find(diagQ./Es<1e-3);       % regular
ngrs = bdry.ngr(js,:) ./ repmat(ks(js), [1 Mo]);
qs = bdry.xoff+(0:Mo-1)*bdry.dx;
figure; axes('position', [.1 .1 .5 .8]);
imagesc(qs, 1:numel(js), -(ngrs).^2);axis tight;caxis([-max(max(ngrs))^2/2 0]);
colormap(gray(256)); xlabel('q'); ylabel('j'); set(gca, 'ydir', 'normal');
print -deps2 -r100 mu0-54ngr2.eps

% or if you want precise k_j values on vertical axis...
figure; surf(qs, ks(js), -abs(ngrs)); view(0,90); axis tight; 

% or if want weyl k values, so all modes given equal plotting weight...
figure; axes('position', [.1 .1 .5 .8]);
% fakejs = (1:numel(js))'*(ne/numel(js));
surf(qs, k_weyl(js), -(ngrs).^2); shading flat; colormap(gray(256));
caxis([-max(max(ngrs))^2/2 0]); view(2); axis tight
xlabel('q'); set(gca, 'ydir', 'normal'); ylabel('k_j');%ylabel('k_{Weyl,j}');
%print -deps2 -r600 mu0-100ngr.eps
%print -djpeg -r600 mu0-100ngr.jpg
% note huge resolution is about right to get one j per pixel at top.

% fourier transform of ngr vs k, at each point q...
qs = bdry.xoff+(0:Mo-1)*bdry.dx;
% resample the irregular k_j sequence onto regular lattice
kmax = 100;
dk = 0.04;
e = 3;          % gaussian width factor, gives sigma = e*dk in k units
nk = ceil(kmax/dk); kk = (0:nk-1)*dk; 
ngrrs = zeros(nk,Mo);
for j=1:ne
  [l,v] = src(nk, ks(j), 1/dk, e); % v is row vec of values
  ngrrs(l,:) = ngrrs(l,:) + kron(v', bdry.ngr(j,:).^2) / Es(j);
end
figure; plot(kk, sum(ngrrs, 2)); xlabel('l'); % check the resampling worked
figure; axes('position', [.1 .1 .5 .8]);
imagesc(qs, kk, -ngrrs); xlabel('q'); set(gca, 'ydir', 'normal');
ylabel('k');colormap(gray(256));             % resampled bdry intensity!
axis([0 max(qs) 0 80]);c=caxis; caxis(c/2);
print -deps2 mu0-80ngrrs.eps

ngrrs = ngrrs .* repmat((kk.*(kmax-kk))', [1 Mo]);  % simple windowing 
ngrft = fft(ngrrs, [], 1); dl = 2*pi/kmax; ls = dl * (0:nk-1); ns = 1:nk/6;
ngrps = ngrft.*conj(ngrft);
ngrps = ngrps .* repmat(exp((e*dk)^2*ls.^2)', [1 Mo]);    % debug
figure; imagesc(qs, ls(ns), log10(ngrps(ns,:))); xlabel('q'); ylabel('l');
set(gca, 'ydir', 'normal'); axis tight; caxis([0 13]); colorbar;
figure; imagesc(qs, ls(ns), -sqrt(ngrps(ns,:))); xlabel('q'); ylabel('l');
set(gca, 'ydir', 'normal'); axis tight; caxis([-3e6 0]); colormap(gray(256));
